// This is called when a form is submitted.
 
var KarmaSendForm = function() {
	var form = $(this);
	var args = {};
	var destination = form.find("input[@name=js_destination]").val();
        var karma_url=karma_base_path + 'simple_karma/handle';

	// If 'destination' is defined, we need to load the destination page rather than submit the vote.
	// This is used to redirect to a login page, for example.

	if (  destination ) {
		top.location = karma_base_path + karma_login_page + '?destination=' + destination;
		return false;
	}

	// The class "tmpClicked" is a simple state variable. It is added as soon as a label is clicked,
	// and removed only once the vote has succeeded or failed. In this way, pending votes are tracked.

	// If an element exists with both the "karma_clicked" and the "tmpClicked", then the user has
	// cast the same vote again. We can ignore it. 

	else if ( form.find('.karma_clicked.tmpClicked').length > 0 ) {
		form.find('.tmpClicked').removeClass('tmpClicked');
		return false;
	}
	
	// Process the vote.
	else {
		// Marshall all AJAX arguments
		args.karma_vote 	= form.find(":selected").val() || form.find(":checked").val();
		args.oid 		= form.find("input[@name=oid]").val();
		args.otype 		= form.find("input[@name=otype]").val();
		args.form_type 		= 'ajax';
		form.addClass("karma_sending");

		// Send the request	
		$.ajax({
			data		: args,
			url		: karma_url,
			type		: 'get',
			dataType: 'json',
			success	: function(json){
				var ts;
				for(var x in json) {args[x] = json[x];}

				// If there's an error, remove "tmpClicked", as the request is no longer pending. 
				if (json.error) {
					form.find(".tmpClicked").removeClass("tmpClicked");
					alert(json.error);
				} else {
					// On success, disable the appropriate forms (SEE KarmaStripForm for more details).
					// Also, ensure only the currently-clicked button has the state "karma_clicked".
					// Remove "tmpClicked", as the request is no longer pending.

					KarmaStripForm(form,args);
					form.addClass("karma_success");
					form.find("label").removeClass("karma_clicked");
					form.find(".tmpClicked").addClass("karma_clicked").removeClass("tmpClicked");
				}
			},
			error : function(xhr,msg){
				// If there's an error, remove "tmpClicked", as the request is no longer pending. 
				form.find(".tmpClicked").removeClass("tmpClicked");
				if (xhr.status==404||!msg) {
					alert("Karma Error: Communication (0)");
				} else {
					alert("Karma Error: "+msg);
				}
			},
			complete: function(xhr,stat) {
				(function(form,args){
					window.setTimeout(function(){
						form.removeClass("karma_sending");
					},2000);
				})(form,args);
			}
		});
		return false;
	}
}

var KarmaStripForm  = function(form,args) {
	if (karma_only_one_vote) {
		form.find("select").attr("disabled","disabled");
		form.find("label").removeClass("karma_clickable").addClass("karma_not_clickable").unbind('click');
	}
	var fid = form.attr("id");
	if ( args.karma_aggregate != "Undefined") {
		for ( var prefix in ( { 'w': 1, 'x': 1, 'y': 1, 'z': 1} ) ) {
			var did = prefix + args.oid;
			$("#" + did + " span.karma_score").text(args.karma_aggregate);
			var did = prefix + args.oid;
			if ( did != fid ) {
				$("#" + did + " *").attr("disabled", "true");
				$("#" + did + " label").removeClass("karma_clickable").addClass("karma_not_clickable").unbind('click');
			}
		}
	}
}

var KarmaRenderForm = function() {
	var form   = $(this);
	var submit = form.find("input[@type=submit]");

	if (! submit.attr("disabled")) {
		form.find("select").change(function(){form.submit();});
		form.find("label").click(function(){
                                      
			if(form.find("#"+$(this).attr("for")+":checked").length > 0) {
				$(this).addClass("tmpClicked");
				form.submit();
			}	
                              
		});
	}
}


/*
var karma_comment_show = function() {
	var button = $(this);
	var parent = button.parent();

	if ( $(".karma_comment_show" ).find(this).length > 0 ) {
		button.removeClass("karma_comment_show");
		button.addClass("karma_comment_hide");
		parent.find("div").each( karma_restore_display );
	}
	else if ( $(".karma_comment_hide" ).find(this).length > 0 ) {
		button.removeClass("karma_comment_hide");
		button.addClass("karma_comment_show");
		parent.find("div").css('display', 'none');
	}
}

var karma_save_display = function() {
	var item = $(this);
	item.attr( "karma-save-display", item.css( 'display' ));
}

var karma_restore_display = function() {
	var item = $(this);
	var disp = item.attr( "karma-save-display" );
	if ( disp ) {
		item.css( "display", disp );
	}
}

var karma_hide_comment = function( val ) {
	var clicked = $(this);
	if ( val && typeof val != 'number' )
	{
		clicked = $(val);
	}
	var comment = clicked.parents( ".comment" );
	if ( comment.find(".karma_down.karma_clicked").length > 0 )
	{
		if ( !( comment.find(".karma_comment_show").length > 0) && !( comment.find(".karma_comment_hide" ).length > 0 )) {
			comment.find('div').each(karma_save_display);
			comment.find('.title').after("<span class='karma_comment_show'>&nbsp;&nbsp;</span>")
			comment.find('.karma_comment_show').click(karma_comment_show);
		}
		comment.find('div').css('display','none');
	}
}
*/

$(function(){
	$("form.karma_form").submit(KarmaSendForm).each(KarmaRenderForm);
	//$(".karma_clicked.karma_down").each(karma_hide_comment);
});
